import java.io.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import org.xml.sax.SAXException; 
import org.xml.sax.SAXParseException; 
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
import org.w3c.dom.*;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;


class SimpleValidator {
    public static void main(String args[]) throws Exception {
	try {

	    //`FbNXML̃t@C̎w
	    if (args.length != 1) {
		System.out.println("Usage: java SimpeValidator <filename>");
		System.exit(1);
	    }
		
	    //DOM̏
	    DocumentBuilderFactory dbf
		= DocumentBuilderFactory.newInstance();

	    // validator
	    dbf.setValidating(true);

	    // Namespace check
	    dbf.setNamespaceAware(true);

	    DocumentBuilder db = dbf.newDocumentBuilder();
	    
	    // ErrorHandler
	    db.setErrorHandler(new MyErrorHandler());

	    //ǂݍ
	    Document doc = db.parse(args[0]);

	} catch (ParserConfigurationException e) {
	    e.printStackTrace();
	} catch (SAXParseException e) {
	    e.printStackTrace();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }
    
    public static  class MyErrorHandler implements ErrorHandler {
	/** Warning. */
	public void warning(SAXParseException ex) {
	    System.err.println("[Warning] "+
			       getLocationString(ex)+": "+
			       ex.getMessage());
	}
	/** Error. */
	public void error(SAXParseException ex) {
	    System.err.println("[Error] "+
			       getLocationString(ex)+": "+
			       ex.getMessage());
	}
	/** Fatal error. */
	public void fatalError(SAXParseException ex) {
	    System.err.println("[Fatal Error] "+
			       getLocationString(ex)+": "+
			       ex.getMessage());
	}
	/** Returns a string of the location. */
	public  String getLocationString(SAXParseException ex) {
	    StringBuffer str = new StringBuffer();

	    String systemId = ex.getSystemId();
	    if (systemId != null) {
		int index = systemId.lastIndexOf('/');
		if (index != -1)
		    systemId = systemId.substring(index + 1);
		str.append(systemId);
	    }
	    str.append(":Line ");
	    str.append(ex.getLineNumber());
	    str.append(':');
	    str.append("Column ");
	    str.append(ex.getColumnNumber());
	    return str.toString();
	}
    }
}
